// (c) Copyright 2013 Cloudera, Inc. All rights reserved.
define([
  'knockout',
  'underscore',
  'cloudera/knockout/ko.tokenize'
], function(ko, _) {
  return function(url) {
    var i = 1;
    var tokens = ko.observableArray();
    // We're dealing with simple strings here.
    var convert = function(val) {
      return {
        id: val,
        name: val
      };
    };
    var viewModel = {
      tokenizeOptions: {
        source: url,
        tokenInputOptions: {
          preventDuplicates: true
        },
        convertServerResponse: function(serverResponse) {
          return _.map(serverResponse, convert);
        },
        convertValue: convert
      },
      tokens: tokens,
      commaDelimited: ko.computed({
        read: function() {
          return tokens().join(',');
        },
        write: function(newValue) {
          if (newValue) {
            var values = newValue.split(',');
            tokens(values);
          } else {
            tokens([]);
          }
        }
      }),
      add: function() {
        tokens.push('Fake thing ' + i);
        i += 1;
      },
      remove: function() {
        tokens.pop();
      }
    };
    ko.applyBindings(viewModel, document.getElementById('tokenizeDemo'));
  };
});